#include <EEPROM.h>
#include "SFE_BMP180.h"
#include <Wire.h>
#include <SoftwareSerial.h>

SoftwareSerial mySerial(10, 11); // RX, TX
SFE_BMP180 pressure;

double baseline;
int addr = 0, valor=0;

// CONFIGURACIÓN
void setup() {
  //INICIAR COMUNICACIÓN SERIE BLUETOOTH
  mySerial.begin(9600);
  delay(500);
  mySerial.println("Inicio correcto Bluetooth");

  //INICIAR SENSOR DE PRESIÓN
  delay(500);
  if (pressure.begin())
    mySerial.println("Inicio correcto (BMP180) ");
  else
  {
    mySerial.println("BMP180 init fail (disconnected?)\n\n");
    while(1); 
  }

}


// LOOP DE FUNCIONAMIENTO
void loop() {

valor=mySerial.read();
switch(valor){

// --- TOMAR DATOS ---
case 49:
  for (int i = 0 ; i < EEPROM.length() ; i++) EEPROM.write(i, 0);
  baseline = getPressure();
  mySerial.println("Tomando datos...");
  tomardatos(); 
  mySerial.println("Todos los datos guardados");
break;

// --- MOSTRAR DATOS ---  
case 50:
  mySerial.println("Vector altura");
  delay(1000);
  mostrardatos(); 
break;

// --- ALTURA MÁXIMA ---
case 51:
  mySerial.print("Altura máxima: ");
  mySerial.println(alturamax());
break;

}
}





//-------------------
//-----FUNCIONES-----
//-------------------

// Función tomar datos
void tomardatos(){
double a,P;
addr=0;
    while(addr < EEPROM.length()){
      P = getPressure();
      a = pressure.altitude(P,baseline)*2.5; 
      if(a<0) a=0;
      EEPROM.write(addr, round(a));
      addr=addr+1;
      delay(6);
    }
}

// Función mostrar datos
void mostrardatos(){
  addr=0;
  while(addr < EEPROM.length()){
    mySerial.println(EEPROM.read(addr)/2.5);
    addr=addr+1;
  }
}


// Función buscar altura máxima
double alturamax(){
  addr=0;
  double aux = 0, alturamaxima = 0;
  while(addr < EEPROM.length()){
    aux = EEPROM.read(addr)/2.5;
    if(aux>alturamaxima)alturamaxima = aux; 
    addr=addr+1;
  }
  return alturamaxima;
}


// Función obtener presión
double getPressure()
{
  char status;
  double T,P;
  status = pressure.startTemperature();
  if (status != 0)
  {
    delay(status);
    status = pressure.getTemperature(T);
    if (status != 0)
    {
      status = pressure.startPressure(3);
      if (status != 0)
      {
        delay(status);
        status = pressure.getPressure(P,T);
        if (status != 0)
        {
          return(P);
        }
        else mySerial.println("error retrieving pressure measurement\n");
      }
      else mySerial.println("error starting pressure measurement\n");
    }
    else mySerial.println("error retrieving temperature measurement\n");
  }
  else mySerial.println("error starting temperature measurement\n");
}
